#!/usr/bin/perl -w

# updown.pl - an example client for LCDproc
#             version 0.0.5
#
# This client for LCDproc displays a up or down message of the red interface.
#
#
# Copyright (c) 1999, William Ferrell, Scott Scriven
#               2001, David Glaude
#               2001, Jarda Benkovsky
#               2002, Jonathan Oxer
#               2002, Rene Wagner <reenoo@gmx.de>
#               2005, Sebastian Foelz <foelz@yahoo.com>
#
# This file is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# any later version.
#
# This file is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#

use IO::Socket;
use Fcntl;
require '/var/ipcop/general-functions.pl';
my $setfile = "/var/ipcop/ppp/settings";
&General::readhash($setfile, \%sett);

############################################################
# Configurable part. Set it according your setup.
############################################################

# Host which runs lcdproc daemon (LCDd)
$HOST = "localhost";

# Port on which LCDd listens to requests
$PORT = "13666";

# These define the visible part of the file...
#$top = 3;    # How far from the end of the file should we start?
#$lines = 3;  # How many lines to display?
#$left = 1;   # Left/right scrolling position,
#$width = 27; # and number of characters per line to show

############################################################
# End of user configurable parts
############################################################

$anz = $#ARGV;
if($anz < 0)
{
    print "Usage: updown.pl \"on|off\"\n";
    print "Options: -s <server>\n";
    print "         -p <port>\n";
    print "default is -s localhost -p 13666\n";
    exit;
}

for ($i=0; $i<=$anz; $i++)
{
    $f2 = shift @ARGV;
    if ("$f2" eq "-s")
    {
	$HOST = shift @ARGV;
	$i++;
    }
    if ("$f2" eq "-p")
    {
	$PORT = shift @ARGV;
	$i++;
    }
    $mesg = $f2;
}
#$mesg = shift @ARGV;
my $redname = $sett{'PROFILENAME'};
open (IPADDR, "/var/ipcop/red/local-ipaddress");
my $ipaddr = <IPADDR>;
close IPADDR;
chomp ($ipaddr);
my $hname = (gethostbyaddr(pack("C4", split(/\./, $ipaddr)), 2))[0];
#debug on
#print "File: $filename : $mesg : $redname\n";
#exit;
#debug off

# Connect to the server...
$remote = IO::Socket::INET->new(
		Proto     => "tcp",
		PeerAddr  => $HOST,
		PeerPort  => $PORT,
	)
	|| die "Cannot connect to LCDproc port\n";

# Make sure our messages get there right away
$remote->autoflush(1);

print $remote "hello\n";
# Note: it's good practice to listen for a response after a print to the
# server even if there isn't meant to be one. If you don't, you may find
# your program crashes after running for a while when the buffers fill up.
my $lcdresponse = <$remote>;
#print $lcdresponse;
my $lines = substr($lcdresponse, 49, 2) - 1;
my $linesx = $lines * 8;
my $width = substr($lcdresponse, 43, 2);
my $widthx = $width * 5;

# Turn off blocking mode...
fcntl($remote, F_SETFL, O_NONBLOCK);


# Set up some screen widgets...
print $remote "client_set name {Tail}\n";
$lcdresponse = <$remote>;
print $remote "screen_add tail\n";
$lcdresponse = <$remote>;
print $remote "screen_set tail -priority 16 name {Tail redif} -heartbeat on\n";
$lcdresponse = <$remote>;
print $remote "widget_add tail title title\n";
$lcdresponse = <$remote>;
print $remote "widget_set tail title {red interface}\n";
$lcdresponse = <$remote>;
print $remote "widget_add tail 1 vbar\n";
$lcdresponse = <$remote>;
print $remote "widget_add tail 2 vbar\n";
$lcdresponse = <$remote>;
print $remote "widget_add tail 3 hbar\n";
$lcdresponse = <$remote>;
print $remote "widget_add tail 1a string\n";
$lcdresponse = <$remote>;
print $remote "widget_add tail 2a string\n";
$lcdresponse = <$remote>;
print $remote "widget_add tail 3a scroller\n";
$lcdresponse = <$remote>;

# Forever, we should do stuff...
$icd = 1;
while($icd)
{

	print $remote "widget_set tail 1 1 2 $linesx\n";
	print $remote "widget_set tail 2 $width 2 $linesx\n";
	print $remote "widget_set tail 3 1 4 $widthx\n";

	# Now, show what the file contains, if anything...
	if( $mesg eq "on" )
	{
		print $remote "widget_set tail 1a 3 2 {$redname is up}\n";
		print $remote "widget_set tail 2a 3 4 {$ipaddr}\n";
		$i = $width -1;
		print $remote "widget_set tail 3a 2 3 $i 3 h 3 {$hname}\n";
		sleep 2;
		if ( length($hname) > $i )
		{
		    sleep 4;
		}
	}
	else
	{
	if( $mesg eq "off" )
	    {
	    	    print $remote "widget_set tail 1a 4 2 {$redname}\n";
		    print $remote "widget_set tail 2a 4 3 {  is down}\n";
	    }
	    else
	    {
		    print $remote "widget_set tail 1a 4 2 {use parameter}\n";
		    print $remote "widget_set tail 2a 4 3 {   on | off}\n";
	    }
	}
	sleep 6;
	$icd = $icd - 1;
}

close ($remote)            || die "close: $!";
exit;
